Index: issm/trunk/src/c/cores/sealevelchange_core.cpp
===================================================================
--- issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 26744)
@@ -136,706 +175,665 @@
 		 * so make sure we are identified as being the Earth.:*/
 		modelid=1; earthid=1; 
-		/* in addition, if we are running solution_type SealevelriseSolutionEnum, make sure we 
-		 * run, irresepective of the time settings:*/
-		count=frequency;
-	}
-
-	/*If we are running in coupled mode, the Earth model needs to run its own mass transport (if 
-	 * not already done by the mass trasnport module. For ice caps, they rely on the transient mass 
-	 * transport module exclusively:*/
-	if(iscoupler) if(modelid==earthid) if(!istransientmasstransport) EarthMassTransport(femmodel);
-
-	/*increment counter, or call solution core if count==frequency:*/
+	}
+
+	/*if we are carrying loads but are not yet computing grd core, accumulate them and skip 
+	 * the rest: */
 	if (count<frequency){
-		count++; femmodel->parameters->SetParam(count,SealevelriseRunCountEnum); 
+		count++; 
+		femmodel->parameters->SetParam(count,SealevelchangeRunCountEnum); 
 		return;
 	}
 
-	/*call sea-level rise sub cores:*/
-	if(iscoupler){
-		/*transfer cumulated deltathickness forcing from ice caps to earth model: */
-		TransferForcing(femmodel,SealevelriseCumDeltathicknessEnum);
-
-		/*we have accumulated thicknesses, dump them in deltathcikness: */
-		if(modelid==earthid)InputDuplicatex(femmodel,SealevelriseCumDeltathicknessEnum,SurfaceloadIceThicknessChangeEnum);
-	}
-
-	/*run cores:*/
-	if(modelid==earthid){
-
-		/*call masks core: */
-		masks=sealevelrise_core_masks(femmodel);
-
-		/*set bottom pressures:*/
-		SetBottomPressure(femmodel);
-
-
-		/*call eustatic core  (generalized eustatic - Farrel and Clark, Eq 4, 1st, 3rd and 4rd terms on the RHS) */
-		RSLg_eustatic=sealevelrise_core_eustatic(femmodel,masks,&oceanarea); 
-
-		/*call non-eustatic core (ocean loading tems  - 2nd and 5th terms on the RHS of Farrel and Clark) */
-		RSLg=sealevelrise_core_noneustatic(femmodel,masks,RSLg_eustatic,oceanarea); 
-
-		/*compute other elastic signatures, such as components of 3-D crustal motion: */
-		sealevelrise_core_elastic(&U_esa,&U_north_esa,&U_east_esa,femmodel,RSLg,masks);
-
-		/*compute viscosus (GIA) signatures:*/
-		sealevelrise_core_viscous(&U_gia,&N_gia,femmodel,RSLg);
-
-		/*compute sea-level rise (low-order spherical harmonics coefficients) diagnostics:*/
-		sealevelrise_diagnostics(femmodel,RSLg);
-
-		/*recover N_esa  = U_esa + RSLg:*/
-		N_esa=U_esa->Duplicate(); U_esa->Copy(N_esa); N_esa->AXPY(RSLg,1);
-
-		/*transform these values into rates (as we only run this once each frequency turn:*/
-		N_esa_rate=N_esa->Duplicate(); N_esa->Copy(N_esa_rate); N_esa_rate->Scale(1/(dt*frequency));
-		U_esa_rate=U_esa->Duplicate(); U_esa->Copy(U_esa_rate); U_esa_rate->Scale(1/(dt*frequency));
-		N_gia_rate=N_gia->Duplicate(); N_gia->Copy(N_gia_rate); N_gia_rate->Scale(1/(dt*frequency));
-		U_gia_rate=U_gia->Duplicate(); U_gia->Copy(U_gia_rate); U_gia_rate->Scale(1/(dt*frequency));
-		RSLg_rate=RSLg->Duplicate(); RSLg->Copy(RSLg_rate); RSLg_rate->Scale(1/(dt*frequency));
-
-		/*get some results into elements:{{{*/
-		InputUpdateFromVectorx(femmodel,U_esa_rate,SealevelUEsaRateEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,N_esa_rate,SealevelNEsaRateEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,U_gia_rate,UGiaRateEnum,VertexSIdEnum);
-		InputUpdateFromVectorx(femmodel,N_gia_rate,NGiaRateEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,RSLg_rate,SealevelRSLRateEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,U_esa,SealevelUEsaEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,N_esa,SealevelNEsaEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,U_gia,UGiaEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,N_gia,NGiaEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,RSLg,SealevelRSLEnum,VertexSIdEnum); 
-		InputUpdateFromVectorx(femmodel,RSLg_eustatic,SealevelRSLEustaticEnum,VertexSIdEnum); 
-
-		if (horiz){
-			InputUpdateFromVectorx(femmodel,U_north_esa,SealevelUNorthEsaEnum,VertexSIdEnum);	// north motion 
-			InputUpdateFromVectorx(femmodel,U_east_esa,SealevelUEastEsaEnum,VertexSIdEnum);		// east motion 
-		} /*}}}*/
-	}
-
-	if(iscoupler){
-		/*transfer sea level back to ice caps:*/
-		TransferSealevel(femmodel,SealevelNEsaRateEnum);
-		TransferSealevel(femmodel,NGiaRateEnum);
-		TransferSealevel(femmodel,SealevelUEsaRateEnum);
-		TransferSealevel(femmodel,UGiaRateEnum);
-
-		//reset cumdeltathickness  to 0: 
-		InputUpdateFromConstantx(femmodel->inputs,femmodel->elements,0.,SealevelriseCumDeltathicknessEnum);
-	}
-
-	/*reset counter to 1:*/
-	femmodel->parameters->SetParam(1,SealevelriseRunCountEnum); //reset counter.
-
-	/*free ressources:{{{*/
-	delete RSLg;
-	delete RSLg_rate;
-	delete RSLg_eustatic;
-	delete U_esa;
-	delete U_esa_rate;
-	delete N_esa;
-	delete N_esa_rate;
-	delete BPg;
-
-	if(horiz){
-		delete U_north_esa;
-		delete U_east_esa;
-	}
-	delete N_gia;
-	delete U_gia;
-	delete N_gia_rate;
-	delete U_gia_rate;
-	//delete masks;
+	/*Basins are supposed to accumulate loads and hand them over to the Earth
+	  for slr computations every "frequency" time steps. If we are here, we
+	  have reached the "frequency"'th time step, and we are going to pick up
+	  the old loads, the current loads, and send them to the Earth for slr
+	  computations.  So the Earth is never supposed to compute loads. Except,
+	  when we are running the Earth as a giant basin (ex: running a
+	  Peltier-style GIA model, or running a "Snow Ball" Earth) which only
+	  happens when we are not coupled, at which point we are sending these
+	  loads to ourselves (hence the convoluted condition).
+	  */
+
+	/*transer loads from basins to Earth for grd core computations. :*/
+	if(iscoupling){
+
+		/*transfer ice thickness change load from basins to earth: */
+		TransferForcing(femmodel,DeltaIceThicknessEnum);
+		TransferForcing(femmodel,DeltaBottomPressureEnum);
+		TransferForcing(femmodel,DeltaTwsEnum);
+
+		/*transfer external forcings back to Earth:*/
+		TransferSealevel(femmodel,BedEnum);
+		TransferSealevel(femmodel,SealevelEnum);
+		if(horiz){
+			TransferSealevel(femmodel,BedEastEnum);
+			TransferSealevel(femmodel,BedNorthEnum);
+		}
+	}
+
+}; /*}}}*/
+void              grd_core(FemModel* femmodel, SealevelGeometry* slgeom) { /*{{{*/
+
+	/*variables:{{{*/
+	int nel;
+	BarystaticContributions* barycontrib=NULL;
+	GenericParam<BarystaticContributions*>* barycontribparam=NULL;
+	IssmDouble polarmotionvector[3]={0};
+
+	GrdLoads*              loads=NULL;
+	Vector<IssmDouble>*    oldsealevelloads=NULL;
+	Vector<IssmDouble>*    oceanareas=NULL;
+	IssmDouble             totaloceanarea;
+	Vector<IssmDouble>*    subelementoceanareas=NULL;
+	IssmDouble             oceanaverage;
+	bool                   scaleoceanarea=false;
+	IssmDouble             rho_water;
+
+	IssmDouble           eps_rel;
+	IssmDouble           eps_abs;
+	int                  max_nonlinear_iterations;
+	int                  iterations=0;
+	int                  step;
+	IssmDouble           time; 
+
+	int  modelid,earthid;
+	int  horiz;
+	int  count,frequency,iscoupling;
+	int  grd=0;
+	int  grdmodel; 
+	int  sealevelloading=0;
+	bool viscous=false;
+	bool rotation=false;
+	bool planethasocean=false;
+	IssmDouble*           sealevelpercpu=NULL;
+
 	/*}}}*/
 
-} 
-/*}}}*/
-void dynstr_core(FemModel* femmodel){ /*{{{*/
-
-	/*variables:*/
-	Vector<IssmDouble> *bedrock  = NULL; 
-	Vector<IssmDouble> *SL  = NULL; 
-	Vector<IssmDouble> *steric_rate_g  = NULL; 
-	Vector<IssmDouble> *dynamic_rate_g = NULL;
-	Vector<IssmDouble> *U_esa_rate= NULL;
-	Vector<IssmDouble> *N_esa_rate= NULL;
-	Vector<IssmDouble> *U_gia_rate= NULL;
-	Vector<IssmDouble> *N_gia_rate= NULL;
-
-	/*parameters: */
-	bool isslr=0;
-	int  solution_type;
-	IssmDouble          dt;
-	int  grd=0;
-	int  step;
-	IssmDouble time;
-	IssmDouble cumgmtslr=0;
-	IssmDouble cumbslr=0;
-	IssmDouble cumgmslr=0;
-	IssmDouble gmtslr=0;
-
-	/*Retrieve parameters:*/
-	femmodel->parameters->FindParam(&isslr,TransientIsslrEnum);
-	femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
-	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
-	femmodel->parameters->FindParam(&grd,SolidearthSettingsGRDEnum);
-	femmodel->parameters->FindParam(&cumgmtslr,CumGmtslrEnum); 
-	femmodel->parameters->FindParam(&cumbslr,CumBslrEnum); 
+	/*Verbose: */
+	if(VerboseSolution()) _printf0_("	  computing GRD patterns\n");
+
+	/*retrieve parameters:{{{*/
+	femmodel->parameters->FindParam(&grd,SolidearthSettingsGRDEnum); 
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
+	femmodel->parameters->FindParam(&count,SealevelchangeRunCountEnum);
 	femmodel->parameters->FindParam(&step,StepEnum);
 	femmodel->parameters->FindParam(&time,TimeEnum);
-
-	/*in case we are running SealevelriseSolutionEnum, then bypass transient settings:*/
-	if(solution_type==SealevelriseSolutionEnum)isslr=1;
-
-	/*Should we be here?:*/
-	if(!isslr)return;
-
-	/*Verbose: */
-	if(VerboseSolution()) _printf0_("	  computing steric sea level rise\n");
-
-	/*Retrieve geoid viscous and elastic rates, bedrock uplift viscous and elastic rates + steric rate, as vectors:*/
-	GetVectorFromInputsx(&bedrock,femmodel,BedEnum,VertexSIdEnum);
-	GetVectorFromInputsx(&SL,femmodel,SealevelEnum,VertexSIdEnum);
-	GetStericRate(&steric_rate_g,femmodel);
-	GetDynamicRate(&dynamic_rate_g,femmodel);
-	if(grd){
-		GetVectorFromInputsx(&U_esa_rate,femmodel,SealevelUEsaRateEnum,VertexSIdEnum);
-		GetVectorFromInputsx(&U_gia_rate,femmodel,UGiaRateEnum,VertexSIdEnum);
-		GetVectorFromInputsx(&N_esa_rate,femmodel,SealevelNEsaRateEnum,VertexSIdEnum);
-		GetVectorFromInputsx(&N_gia_rate,femmodel,NGiaRateEnum,VertexSIdEnum);
-	}
-
-	/*Save steric rate, and cumulate it through time, cumulate with barystatic sea level rise, and cumulate through time:*/
-	gmtslr=steric_rate_g->Max()*dt;
-	cumgmtslr+=gmtslr;
-	cumgmslr=cumbslr+cumgmtslr;
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,GmtslrEnum,gmtslr,step,time));
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumGmtslrEnum,cumgmtslr,step,time));
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumGmslrEnum,cumgmslr,step,time));
-	femmodel->parameters->SetParam(cumgmtslr,CumGmtslrEnum);
-
-	/*compute: sea level change = initial sea level + (N_gia_rate+N_esa_rate)  * dt + steric_rate + dynamic_rate dt*/
-	if(grd){
-		SL->AXPY(N_gia_rate,dt);
-		SL->AXPY(N_esa_rate,dt);
-	}
-	SL->AXPY(steric_rate_g,dt);
-	SL->AXPY(dynamic_rate_g,dt);
-
-	/*compute new bedrock position: */
-	if(grd){
-		bedrock->AXPY(U_esa_rate,dt);
-		bedrock->AXPY(U_gia_rate,dt);
-	}
-
-	/*update element inputs:*/
-	InputUpdateFromVectorx(femmodel,bedrock,BedEnum,VertexSIdEnum);	
-	InputUpdateFromVectorx(femmodel,SL,SealevelEnum,VertexSIdEnum);	
-
-	/*Free ressources:*/	
-	delete bedrock;
-	delete SL;
-	delete steric_rate_g;
-	delete dynamic_rate_g;
-	if(grd){
-		delete U_esa_rate;
-		delete U_gia_rate;
-		delete N_esa_rate;
-		delete N_gia_rate;
-	}
+	femmodel->parameters->FindParam(&sealevelloading,SolidearthSettingsSealevelLoadingEnum);
+	femmodel->parameters->FindParam(&max_nonlinear_iterations,SolidearthSettingsMaxiterEnum);
+	femmodel->parameters->FindParam(&viscous,SolidearthSettingsViscousEnum);
+	femmodel->parameters->FindParam(&rotation,SolidearthSettingsRotationEnum);
+	femmodel->parameters->FindParam(&planethasocean,SolidearthSettingsGrdOceanEnum);
+	/*}}}*/
+
+	/*only run if grd was requested, if we are the earth, and we have reached
+	 * the necessary number of time steps dictated by :*/
+	if(!grd)            return;
+	if(count!=frequency)return;
+	femmodel->parameters->FindParam(&iscoupling,IsSlcCouplingEnum);
+	if(iscoupling){
+		femmodel->parameters->FindParam(&modelid,ModelIdEnum);
+		femmodel->parameters->FindParam(&earthid,EarthIdEnum);
+		if(modelid!=earthid)return;
+	}
+	/*branch directly to Ivins deformation core if requested:*/
+	if(grdmodel==IvinsEnum){
+		ivins_deformation_core(femmodel);
+		return;
+	}
+
+	/*retrieve parameters: {{{*/ 
+	femmodel->parameters->FindParam(&scaleoceanarea,SolidearthSettingsOceanAreaScalingEnum);
+	barycontribparam = xDynamicCast<GenericParam<BarystaticContributions*>*>(femmodel->parameters->FindParamObject(BarystaticContributionsEnum));
+	barycontrib=barycontribparam->GetParameterValue();
+	femmodel->parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
+	femmodel->parameters->FindParam(&eps_rel,SolidearthSettingsReltolEnum);
+	femmodel->parameters->FindParam(&eps_abs,SolidearthSettingsAbstolEnum);
+	femmodel->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+	/*}}}*/
+
+	/*initialize loads and sea level loads:*/
+	femmodel->parameters->FindParam(&nel,MeshNumberofelementsEnum);
+
+	loads=new GrdLoads(nel,slgeom);
+	subelementoceanareas=new Vector<IssmDouble>(slgeom->nbar[SLGEOM_OCEAN]);
+	oceanareas=new Vector<IssmDouble>(nel);
+	sealevelpercpu=xNewZeroInit<IssmDouble>(femmodel->vertices->Size());
+
+	if(VerboseSolution()) _printf0_("	  starting  GRD convolutions\n");
+
+	/*update viscous RSL:*/
+	for(Object* & object : femmodel->elements->objects){
+		Element* element = xDynamicCast<Element*>(object);
+		element->SealevelchangeUpdateViscousFields();
+	}
+
+	/*buildup loads: */
+	for(Object* & object : femmodel->elements->objects){
+		Element* element = xDynamicCast<Element*>(object);
+		element->SealevelchangeBarystaticLoads(loads, barycontrib,slgeom); 
+	}
+
+	//broadcast loads 
+	loads->BroadcastLoads();
+
+	//compute polar motion:
+	PolarMotion(&polarmotionvector[0],femmodel,loads,slgeom);
+
+	/*skip computation of sea level equation if requested, which means sea level loads should be zeroed */
+	if(!sealevelloading){
+		loads->sealevelloads=xNewZeroInit<IssmDouble>(nel);
+		loads->subsealevelloads=xNewZeroInit<IssmDouble>(slgeom->nbar[SLGEOM_OCEAN]);
+
+		goto deformation;
+	}
+
+	if(VerboseSolution()) _printf0_("	  converging GRD convolutions\n");
+	for(;;){
+
+		oldsealevelloads=loads->vsealevelloads->Duplicate(); loads->vsealevelloads->Copy(oldsealevelloads);
+
+		/*convolve load and sealevel loads on oceans:*/
+		for(Object* & object : femmodel->elements->objects){
+			Element* element = xDynamicCast<Element*>(object);
+			element->SealevelchangeConvolution(sealevelpercpu, loads , polarmotionvector,slgeom);
+		}
+
+		/*retrieve sea level average  and ocean area:*/
+		for(Object* & object : femmodel->elements->objects){
+			Element* element = xDynamicCast<Element*>(object);
+			element->SealevelchangeOceanAverage(loads, oceanareas, subelementoceanareas, sealevelpercpu, slgeom);
+		}
+
+		loads->AssembleSealevelLoads();
+
+		/*compute ocean areas:*/
+		if(!loads->sealevelloads){ //first time in the loop
+			oceanareas->Assemble(); 
+			subelementoceanareas->Assemble();
+			oceanareas->Sum(&totaloceanarea); _assert_(totaloceanarea>0.);
+			if(scaleoceanarea) totaloceanarea=3.619e+14; // use true ocean area, m^2
+		}
+
+		//Conserve ocean mass: 
+		oceanaverage=SealevelloadsOceanAverage(loads, oceanareas,subelementoceanareas, totaloceanarea);
+		ConserveOceanMass(femmodel,loads,barycontrib->Total()/totaloceanarea - oceanaverage,slgeom);
+
+		//broadcast sea level loads 
+		loads->BroadcastSealevelLoads();
+
+		//compute polar motion:
+		PolarMotion(&polarmotionvector[0],femmodel,loads, slgeom);
+
+		//convergence?
+		if(slcconvergence(loads->vsealevelloads,oldsealevelloads,eps_rel,eps_abs))break;
+
+		//early return?
+		if(iterations>=max_nonlinear_iterations)break;
+		iterations++;
+	}
+
+	deformation:
+
+	if(VerboseSolution()) _printf0_("	  deformation GRD convolutions\n");
+
+	/*convolve loads and sea level loads to get the deformation:*/
+	for(Object* & object : femmodel->elements->objects){
+		Element* element = xDynamicCast<Element*>(object);
+		element->SealevelchangeDeformationConvolution(sealevelpercpu, loads, polarmotionvector,slgeom);
+	}
+
+	if(VerboseSolution()) _printf0_("	  updating GRD fields\n");
+
+	if(planethasocean){
+		if (!sealevelloading){ //we haven't done so before, so we need to compute the ocean average and area
+			loads->sealevelloads=NULL; //needed to trigger the calculation of areas
+			/*retrieve sea level average  and ocean area:*/
+			for(Object* & object : femmodel->elements->objects){
+				Element* element = xDynamicCast<Element*>(object);
+				element->SealevelchangeOceanAverage(loads, oceanareas, subelementoceanareas, sealevelpercpu, slgeom);
+			}
+			loads->sealevelloads=xNewZeroInit<IssmDouble>(nel);
+			loads->AssembleSealevelLoads();
+			/*compute ocean areas:*/
+			oceanareas->Assemble(); 
+			subelementoceanareas->Assemble();
+			oceanareas->Sum(&totaloceanarea); _assert_(totaloceanarea>0.);
+			if(scaleoceanarea) totaloceanarea=3.619e+14; // use true ocean area, m^2
+
+			//Conserve ocean mass
+			//Note that here we create sea-level loads but they will not generate GRD as we have already run all the convolutions
+			oceanaverage=SealevelloadsOceanAverage(loads, oceanareas,subelementoceanareas, totaloceanarea);
+			ConserveOceanMass(femmodel,loads,barycontrib->Total()/totaloceanarea - oceanaverage,slgeom);
+		}
+
+		femmodel->inputs->Shift(SealevelGRDEnum,barycontrib->Total()/rho_water/totaloceanarea- oceanaverage/rho_water);
+
+		//cumulate barystatic contributions and save to results: 
+		barycontrib->Cumulate(femmodel->parameters);
+		barycontrib->Save(femmodel->results,femmodel->parameters,totaloceanarea);
+		barycontrib->Reset();
+	}
+
+	if (rotation) {
+		femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,SealevelInertiaTensorXZEnum,polarmotionvector[0],step,time));
+		femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,SealevelInertiaTensorYZEnum,polarmotionvector[1],step,time));
+		femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,SealevelInertiaTensorZZEnum,polarmotionvector[2],step,time));
+	}
+
+	/*Update bedrock motion and geoid:*/
+	femmodel->inputs->AXPY(1,SealevelGRDEnum,SealevelEnum);
+	femmodel->inputs->AXPY(1,BedGRDEnum,BedEnum);
+	if(horiz){
+		femmodel->inputs->AXPY(1,BedEastGRDEnum,BedEastEnum);
+		femmodel->inputs->AXPY(1,BedNorthGRDEnum, BedNorthEnum);
+	}
+
 }
 /*}}}*/
-
-SealevelMasks* sealevelrise_core_masks(FemModel* femmodel) {  /*{{{*/
-
-	if(VerboseSolution()) _printf0_("	  computing sea level masks\n");
-	
-	/*initialize SealevelMasks structure: */
-	SealevelMasks* masks=new SealevelMasks(femmodel->elements->Size());
-
-	/*go through elements and fill the masks: */
+void              dynstr_core(FemModel* femmodel){ /*{{{*/
+
+	/*variables:*/
+	Vector<IssmDouble> *sealevel  = NULL; 
+	Vector<IssmDouble> *deltadsl  = NULL; 
+	Vector<IssmDouble> *deltastr = NULL;
+
+	/*parameters: */
+	int  step;
+	bool isocean=false;
+	IssmDouble time;
+
+	IssmDouble cumgmtslc=0;
+	IssmDouble cumbslc=0;
+	IssmDouble cumgmslc=0;
+	IssmDouble gmtslc=0;
+
+	/*early return if we have no ocean transport:*/
+	femmodel->parameters->FindParam(&isocean,TransientIsoceantransportEnum);
+	if(!isocean)return;
+
+	/*Verbose: */
+	if(VerboseSolution()) _printf0_("	  computing steric and dynamic sea level change\n");
+
+	/*Retrieve sealevel and add steric + dynamic rates:*/
+	GetVectorFromInputsx(&sealevel,femmodel,SealevelEnum,VertexSIdEnum);
+	GetVectorFromInputsx(&deltadsl,femmodel,DeltaDslEnum,VertexSIdEnum);
+	GetVectorFromInputsx(&deltastr,femmodel,DeltaStrEnum,VertexSIdEnum);
+
+	/*compute: sea level change = initial sea level + steric + dynamic*/
+	sealevel->AXPY(deltadsl,1);
+	sealevel->AXPY(deltastr,1);
+
+	/*cumulate thermal steric rate:*/
+	femmodel->parameters->FindParam(&cumgmtslc,CumGmtslcEnum); 
+	femmodel->parameters->FindParam(&cumbslc,CumBslcEnum); 
+
+	gmtslc=deltastr->Norm(NORM_TWO);
+	cumgmtslc+=gmtslc;
+	cumgmslc=cumbslc+cumgmtslc;
+
+	femmodel->parameters->SetParam(cumgmtslc,CumGmtslcEnum);
+	femmodel->parameters->SetParam(cumgmslc,CumGmslcEnum);
+
+	/*Outputs some metrics:*/
+	femmodel->parameters->FindParam(&step,StepEnum);
+	femmodel->parameters->FindParam(&time,TimeEnum);
+
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,GmtslcEnum,gmtslc,step,time));
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumGmtslcEnum,cumgmtslc,step,time));
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumGmslcEnum,cumgmslc,step,time));
+
+	/*update element inputs:*/
+	InputUpdateFromVectorx(femmodel,sealevel,SealevelEnum,VertexSIdEnum);	
+
+	/*Free ressources:*/	
+	delete sealevel;
+	delete deltadsl;
+	delete deltastr;
+}
+/*}}}*/
+void              coupleroutput_core(FemModel* femmodel){  /*{{{*/
+
+	/*parameters:*/
+	int iscoupling;
+	int horiz=0;
+
+	/*retrieve more parameters:*/
+	femmodel->parameters->FindParam(&iscoupling,IsSlcCouplingEnum);
+	femmodel->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+
+	if(iscoupling){
+		/*transfer sea level back to ice caps:*/
+		TransferSealevel(femmodel,SealevelEnum);
+		TransferSealevel(femmodel,BedEnum);
+		if(horiz){
+			TransferSealevel(femmodel,BedNorthEnum);
+			TransferSealevel(femmodel,BedEastEnum);
+		}
+	}
+}; /*}}}*/
+void              ivins_deformation_core(FemModel* femmodel){ /*{{{*/
+
+	int  gsize;
+	Vector<IssmDouble> *bedup  = NULL; 
+	Vector<IssmDouble> *beduprate= NULL; 
+	IssmDouble          *xx     = NULL;
+	IssmDouble          *yy     = NULL;
+
+	if(VerboseSolution()) _printf0_("	  computing vertical deformation using Ivins model. \n");
+
+	/*find size of vectors:*/
+	gsize      = femmodel->nodes->NumberOfDofs(GsetEnum);
+
+	/*Find the litho material to be used by all the elements:*/
+	Matlitho* matlitho=NULL;
+	for (Object* & object: femmodel->materials->objects){
+		Material* material=xDynamicCast<Material*>(object);
+		if(material->ObjectEnum()==MatlithoEnum){
+			matlitho=xDynamicCast<Matlitho*>(material);
+			break;
+		}
+	}
+
+	/*initialize vectors:*/
+	bedup = new Vector<IssmDouble>(gsize);
+	beduprate = new Vector<IssmDouble>(gsize);
+
+	/*retrieve geometric information: */
+	VertexCoordinatesx(&xx,&yy,NULL,femmodel->vertices); 
+
+	/*Go through elements, and add contribution from each element to the deflection vector wg:*/
+	for(Object* & object : femmodel->elements->objects){
+		Element* element = xDynamicCast<Element*>(object);
+		element->GiaDeflection(bedup,beduprate, matlitho, xx,yy);
+	}
+
+	/*Assemble parallel vector:*/
+	beduprate->Assemble();
+	bedup->Assemble();
+
+	/*Save results:*/
+	InputUpdateFromVectorx(femmodel,bedup,BedGRDEnum,VertexSIdEnum);
+	femmodel->inputs->AXPY(1,BedGRDEnum,BedEnum);
+
+	/*Free ressources: */
+	xDelete<IssmDouble>(xx);
+	xDelete<IssmDouble>(yy);
+	delete beduprate;
+	delete bedup;
+}
+/*}}}*/
+void              sealevelchange_initialgeometry(FemModel* femmodel) {  /*{{{*/
+
+	/*Geometry core where we compute geometrical kernels and weights:*/
+
+	/*parameters: */
+	IssmDouble *xxe    = NULL;
+	IssmDouble *yye    = NULL;
+	IssmDouble *zze    = NULL;
+	IssmDouble* areae  = NULL;
+	int  nel;
+	int  grdmodel=0;
+
+	/*retrieve parameters:*/
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	nel=femmodel->elements->NumberOfElements();
+
+	/*early return?:*/
+	if(grdmodel==IvinsEnum) return;
+
+	/*Verbose: */
+	if(VerboseSolution()) _printf0_("	  computing initial sea level geometrical kernels and weights.\n");
+
+	/*recover x,y,z and areas from elements: */
+	ElementCoordinatesx(&xxe,&yye,&zze,&areae,femmodel->elements);
+
+	/*Run sealevel geometry routine in elements:*/
 	for(Object* & object : femmodel->elements->objects){
 		Element*   element=xDynamicCast<Element*>(object);
-		element->SetSealevelMasks(masks);
-	}
-
-	return masks;
+		element->SealevelchangeGeometryInitial(xxe,yye,zze,areae);
+	}
+
+	femmodel->parameters->AddObject(new DoubleVecParam(XxeEnum,xxe,nel));
+	femmodel->parameters->AddObject(new DoubleVecParam(YyeEnum,yye,nel));
+	femmodel->parameters->AddObject(new DoubleVecParam(ZzeEnum,zze,nel));
+	femmodel->parameters->AddObject(new DoubleVecParam(AreaeEnum,areae,nel));
+
+	#ifdef _ISSM_DEBUG_
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble*>(femmodel->results->Size()+1,XxeEnum,xxe,nel,1,1,1));
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble*>(femmodel->results->Size()+1,YyeEnum,yye,nel,1,1,1));
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble*>(femmodel->results->Size()+1,ZzeEnum,zze,nel,1,1,1));
+	femmodel->results->AddResult(new GenericExternalResult<IssmDouble*>(femmodel->results->Size()+1,AreaeEnum,areae,nel,1,1,1));
+	#endif
+
+	return;
+
 }/*}}}*/
-void sealevelrise_core_geometry(FemModel* femmodel) {  /*{{{*/
-
-	/*Geometry core where we compute indices into tables pre computed in the SealevelRiseAnalysis: */
+SealevelGeometry* sealevelchange_geometry(FemModel* femmodel) {  /*{{{*/
+
+	/*Geometry core where we compute updates to the Green function kernels and weights, dependent 
+	 * on the evolution of levelsets: */
 
 	/*parameters: */
-	bool spherical=true;
-	IssmDouble *latitude  = NULL;
-	IssmDouble *longitude = NULL;
-	IssmDouble *radius    = NULL;
-	IssmDouble *xx    = NULL;
-	IssmDouble *yy    = NULL;
-	IssmDouble *zz    = NULL;
-	int  horiz;
-	bool geometrydone = false;
-
-		
+	IssmDouble *xxe    = NULL;
+	IssmDouble *yye    = NULL;
+	IssmDouble *zze    = NULL;
+	IssmDouble* areae  = NULL;
+
+	int nel;
+	int  grdmodel=0;
+	SealevelGeometry* slgeom=NULL;
+
+	/*early return?:*/
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	if(grdmodel==IvinsEnum) return NULL;
+
 	/*retrieve parameters:*/
-	femmodel->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
-	femmodel->parameters->FindParam(&geometrydone,SealevelriseGeometryDoneEnum);
-
-	if(geometrydone){
-		if(VerboseSolution()) _printf0_("	  geometrical offsets have already been computed, skipping \n");
-		return; //don't need to run this again.
-	}
+	femmodel->parameters->FindParam(&xxe,&nel,XxeEnum);
+	femmodel->parameters->FindParam(&yye,&nel,YyeEnum);
+	femmodel->parameters->FindParam(&zze,&nel,ZzeEnum);
+	femmodel->parameters->FindParam(&areae,&nel,AreaeEnum);
+
+	/*initialize SealevelloadMasks structure: */
+	slgeom=new SealevelGeometry(femmodel->elements->Size(),femmodel->vertices->Size());
 
 	/*Verbose: */
-	if(VerboseSolution()) _printf0_("	  computing geometrical offsets into precomputed Green tables \n");
-
-	/*first, recover lat,long and radius vectors from vertices: */
-	VertexCoordinatesx(&latitude,&longitude,&radius,femmodel->vertices,spherical); 
-	if(horiz) VertexCoordinatesx(&xx,&yy,&zz,femmodel->vertices); 
-
-
-	/*Run sealevelrise geometry routine in elements:*/
+	if(VerboseSolution()) _printf0_("	  computing sea level geometrical kernel and weight updates.\n");
+
+	/*Run sealevel geometry routine for elements with full loading:*/
 	for(Object* & object : femmodel->elements->objects){
 		Element*   element=xDynamicCast<Element*>(object);
-		element->SealevelriseGeometry(latitude,longitude,radius,xx,yy,zz);
-	}
-
-	/*Free ressources:*/
-	if(horiz){
-		xDelete<IssmDouble>(xx);
-		xDelete<IssmDouble>(yy);
-		xDelete<IssmDouble>(zz);
-	}
-	xDelete<IssmDouble>(latitude);
-	xDelete<IssmDouble>(longitude);
-	xDelete<IssmDouble>(radius);
-
-	/*Record the fact that we ran this module already: */
-	femmodel->parameters->SetParam(true,SealevelriseGeometryDoneEnum); 
-
+		element->SealevelchangeGeometryCentroidLoads(slgeom,xxe,yye,zze,areae);
+	}
+
+	/*Initialize fractional loading mapping: */
+	slgeom->InitializeMappingsAndBarycentres();
+
+	/*Run sealevel geometry routine for elements with fractional loading:*/
+	for(Object* & object : femmodel->elements->objects){
+		Element*   element=xDynamicCast<Element*>(object);
+		element->SealevelchangeGeometrySubElementLoads(slgeom,areae);
+	}
+
+	/*Assemble barycentres of fraction loading elements:*/
+	slgeom->Assemble();
+
+	/*Create fractional green function kernels: */
+	for(Object* & object : femmodel->elements->objects){
+		Element*   element=xDynamicCast<Element*>(object);
+		element->SealevelchangeGeometrySubElementKernel(slgeom);
+	}
+
+	femmodel->parameters->AddObject(new DoubleVecParam(XxeEnum,xxe,nel));
+	femmodel->parameters->AddObject(new DoubleVecParam(YyeEnum,yye,nel));
+	femmodel->parameters->AddObject(new DoubleVecParam(ZzeEnum,zze,nel));
+	femmodel->parameters->AddObject(new DoubleVecParam(AreaeEnum,areae,nel));
+
+	return slgeom;
 
 }/*}}}*/
-Vector<IssmDouble>* sealevelrise_core_eustatic(FemModel* femmodel,SealevelMasks* masks, IssmDouble* poceanarea){ /*{{{*/
-
-	/*Eustatic core of the SLR solution (terms that are constant with respect to sea-level)*/
-
-	Vector<IssmDouble> *RSLgi    = NULL;
-	IssmDouble          RSLgi_oceanaverage   = 0;
-
-	/*parameters: */
-	int  gsize;
-	IssmDouble oceanarea;
-	int        step;
-	IssmDouble time;
-
-	/*barystatic contribution:*/
-	IssmDouble bslr;
-	IssmDouble bslrice;
-	IssmDouble* bslrice_partition=NULL;
-	IssmDouble bslrhydro;
-	IssmDouble* bslrhydro_partition=NULL;
-	IssmDouble cumbslr;
-	IssmDouble cumbslrice;
-	IssmDouble cumbslrhydro;
-	IssmDouble* cumbslrice_partition=NULL;
-	int npartice;
-	IssmDouble* cumbslrhydro_partition=NULL;
-	int nparthydro;
-	
-	if(VerboseSolution()) _printf0_("	  computing bslr components on ice\n");
-
-	/*Figure out size of g-set deflection vector and allocate solution vector: */
-	gsize = femmodel->nodes->NumberOfDofs(GsetEnum);
-
-	/*some parameters:*/
-	femmodel->parameters->FindParam(&step,StepEnum);
-	femmodel->parameters->FindParam(&time,TimeEnum);
-	femmodel->parameters->FindParam(&cumbslr,CumBslrEnum);
-	femmodel->parameters->FindParam(&cumbslrice,CumBslrIceEnum);
-	femmodel->parameters->FindParam(&cumbslrhydro,CumBslrHydroEnum);
-	femmodel->parameters->FindParam(&npartice,SolidearthNpartIceEnum);
-	femmodel->parameters->FindParam(&nparthydro,SolidearthNpartHydroEnum);
-	if(npartice) femmodel->parameters->FindParam(&cumbslrice_partition,&npartice,NULL,CumBslrIcePartitionEnum);
-	if(nparthydro) femmodel->parameters->FindParam(&cumbslrhydro_partition,&nparthydro,NULL,CumBslrHydroPartitionEnum);
-
-	/*Initialize:*/
-	RSLgi = new Vector<IssmDouble>(gsize);
-
-	/*call the bslr main module: */
-	femmodel->SealevelriseEustatic(RSLgi,&oceanarea,&bslr, &bslrice, &bslrhydro, &bslrice_partition, &bslrhydro_partition,masks); //this computes 
-
-	/*we need to average RSLgi over the ocean: RHS term  4 in Eq.4 of Farrel and clarke. Only the elements can do that: */
-	RSLgi_oceanaverage=femmodel->SealevelriseOceanAverage(RSLgi,masks, oceanarea);
-
-	/*RSLg is the sum of the pure bslr component (term 3) and the contribution from the perturbation to the graviation potential due to the 
-	 * presence of ice (terms 1 and 4 in Eq.4 of Farrel and Clarke):*/
-	RSLgi->Shift(-bslr-RSLgi_oceanaverage);
-
-	/*save bslr and cumulated bslr value for results:{{{ */
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,BslrEnum,-bslr,step,time));
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,BslrIceEnum,-bslrice,step,time));
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,BslrHydroEnum,-bslrhydro,step,time));
-
-	//cumulative barystatic contribution: 
-	cumbslr=cumbslr-bslr;
-	cumbslrice=cumbslrice-bslrice;
-	cumbslrhydro=cumbslrhydro-bslrhydro;
-
-	femmodel->parameters->SetParam(cumbslr,CumBslrEnum);
-	femmodel->parameters->SetParam(cumbslrice,CumBslrIceEnum);
-	femmodel->parameters->SetParam(cumbslrhydro,CumBslrHydroEnum);
-
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumBslrEnum,cumbslr,step,time));
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumBslrIceEnum,cumbslrice,step,time));
-	femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,CumBslrHydroEnum,cumbslrhydro,step,time));
-
-	//cumulative barystatic contributions by partition:
-	if(npartice){
-		for(int i=0;i<npartice;i++) cumbslrice_partition[i] -= bslrice_partition[i];
-		femmodel->parameters->SetParam(cumbslrice_partition,npartice,1,CumBslrIcePartitionEnum);
-		femmodel->results->AddResult(new GenericExternalResult<IssmDouble*>(femmodel->results->Size()+1,CumBslrIcePartitionEnum,cumbslrice_partition,npartice,1,step,time));
-	}
-
-	if(nparthydro){
-		for(int i=0;i<nparthydro;i++) cumbslrhydro_partition[i] -= bslrhydro_partition[i];
-		femmodel->parameters->SetParam(cumbslrhydro_partition,nparthydro,1,CumBslrHydroPartitionEnum);
-		femmodel->results->AddResult(new GenericExternalResult<IssmDouble*>(femmodel->results->Size()+1,CumBslrHydroPartitionEnum,cumbslrhydro_partition,nparthydro,1,step,time));
-	}
-	/*}}}*/
-	
-	/*Assign output pointers and return: */
-	*poceanarea=oceanarea;
-	return RSLgi;
-}/*}}}*/
-Vector<IssmDouble>* sealevelrise_core_noneustatic(FemModel* femmodel, SealevelMasks* masks, Vector<IssmDouble>* RSLg_eustatic,IssmDouble oceanarea){ /*{{{*/
-
-	/*sealevelrise_core_noneustatic.cpp //this computes the contributions from Eq.4 of Farrel and Clarke, rhs terms 2 and 5.
-	  non eustatic core of the SLR solution */
-
-	Vector<IssmDouble> *RSLg    = NULL;
-	Vector<IssmDouble> *RSLg_old    = NULL;
-
-	Vector<IssmDouble> *RSLgo    = NULL; //ocean convolution of the perturbation to gravity potential.
-	Vector<IssmDouble> *RSLgo_rot= NULL; // rotational feedback 
-	IssmDouble          RSLgo_oceanaverage = 0;  //average of RSLgo over the ocean.
-
-	/*parameters: */
-	int count;
-	bool save_results;
-	int  gsize;
+
+/*subroutines:*/
+bool slcconvergence(Vector<IssmDouble>* RSLg,Vector<IssmDouble>* RSLg_old,IssmDouble eps_rel,IssmDouble eps_abs){ /*{{{*/
+
 	bool converged=true;
-	bool rotation=true;
-	bool verboseconvolution=true;
-	int max_nonlinear_iterations;
-	IssmDouble           eps_rel;
-	IssmDouble           eps_abs;
-	IssmDouble			Ixz, Iyz, Izz; 
-	
-	if(VerboseSolution()) _printf0_("	  converging on ocean components\n");
-
-	/*Recover some parameters: */
-	femmodel->parameters->FindParam(&max_nonlinear_iterations,SolidearthSettingsMaxiterEnum);
-	femmodel->parameters->FindParam(&eps_rel,SolidearthSettingsReltolEnum);
-	femmodel->parameters->FindParam(&eps_abs,SolidearthSettingsAbstolEnum);
-
-	/*computational flag: */
+	IssmDouble ndS,nS; 
+	Vector<IssmDouble> *dRSLg    = NULL;
+
+	//compute norm(du) and norm(u) if requested
+	dRSLg=RSLg_old->Duplicate(); RSLg_old->Copy(dRSLg); dRSLg->AYPX(RSLg,-1.0);
+	ndS=dRSLg->Norm(NORM_TWO); 
+
+	if (xIsNan<IssmDouble>(ndS)){
+		_error_("convergence criterion is NaN (RSL_old=" << RSLg_old->Norm(NORM_TWO) << " RSL=" << RSLg->Norm(NORM_TWO) << ")");
+	}
+
+	if(!xIsNan<IssmDouble>(eps_rel)){
+		nS=RSLg_old->Norm(NORM_TWO);
+		if (xIsNan<IssmDouble>(nS)) _error_("convergence criterion is NaN! (check the initial RSL)");
+	}
+
+	//clean up
+	delete dRSLg;
+
+	//print
+	if(!xIsNan<IssmDouble>(eps_rel)){
+		if((ndS/nS)<eps_rel){
+			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)/norm(S)" << ndS/nS*100 << " < " << eps_rel*100 << " %\n");
+		}
+		else{ 
+			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)/norm(S)" << ndS/nS*100 << " > " << eps_rel*100 << " %\n");
+			converged=false;
+		}
+	}
+	if(!xIsNan<IssmDouble>(eps_abs)){
+		if(ndS<eps_abs){
+			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)" << ndS << " < " << eps_abs << " \n");
+		}
+		else{ 
+			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)" << ndS << " > " << eps_abs << " \n");
+			converged=false;
+		}
+	}
+
+	/*assign output*/
+	return converged;
+
+} /*}}}*/
+IssmDouble  SealevelloadsOceanAverage(GrdLoads* loads, Vector<IssmDouble>* oceanareas, Vector<IssmDouble>* suboceanareas, IssmDouble totaloceanarea){ /*{{{*/
+
+	IssmDouble sealevelloadsaverage;	
+	IssmDouble subsealevelloadsaverage;	
+
+	Vector<IssmDouble>* vsealevelloadsvolume=loads->vsealevelloads->Duplicate();
+	Vector<IssmDouble>* vsubsealevelloadsvolume=loads->vsubsealevelloads->Duplicate();
+
+	vsealevelloadsvolume->PointwiseMult(loads->vsealevelloads,oceanareas);
+	vsubsealevelloadsvolume->PointwiseMult(loads->vsubsealevelloads,suboceanareas);
+
+	vsealevelloadsvolume->Sum(&sealevelloadsaverage);
+	vsubsealevelloadsvolume->Sum(&subsealevelloadsaverage);
+	delete vsealevelloadsvolume; 
+	delete vsubsealevelloadsvolume; 
+
+	return (sealevelloadsaverage+subsealevelloadsaverage)/totaloceanarea;
+} /*}}}*/
+void PolarMotion(IssmDouble* polarmotionvector, FemModel* femmodel,GrdLoads* loads, SealevelGeometry* slgeom){ /*{{{*/
+
+	IssmDouble  moi_list[3]={0,0,0};
+	IssmDouble  moi_list_sub[3]={0,0,0};
+	IssmDouble  moi_list_cpu[3]={0,0,0};
+	IssmDouble*	tide_love_h  = NULL;
+	IssmDouble*	tide_love_k  = NULL;
+	IssmDouble*	load_love_k  = NULL;
+	IssmDouble  tide_love_k2secular;
+	IssmDouble  moi_e, moi_p;
+	IssmDouble	m1, m2, m3;
+	bool rotation=false;
+
+	/*early return?:*/
 	femmodel->parameters->FindParam(&rotation,SolidearthSettingsRotationEnum);
-
-	/*Figure out size of g-set deflection vector and allocate solution vector: */
-	gsize = femmodel->nodes->NumberOfDofs(GsetEnum);
-
-	/*Initialize:*/
-	RSLg = new Vector<IssmDouble>(gsize);
-	RSLg->Assemble();
-	RSLg_eustatic->Copy(RSLg);  //first initialize RSLg with the eustatic component computed in sealevelrise_core_eustatic.
-
-	RSLg_old = new Vector<IssmDouble>(gsize);
-	RSLg_old->Assemble();
-
-	count=1;
-	converged=false;
-
-	/*Start loop: */
-	for(;;){
-
-		//save pointer to old sea level rise
-		delete RSLg_old; RSLg_old=RSLg; 
-
-		/*Initialize solution vector: */
-		RSLg  = new Vector<IssmDouble>(gsize); RSLg->Assemble();
-		RSLgo = new Vector<IssmDouble>(gsize); RSLgo->Assemble();
-
-		/*call the non eustatic module: */
-		femmodel->SealevelriseNonEustatic(RSLgo, RSLg_old,  masks, verboseconvolution);
-
-		/*assemble solution vector: */
-		RSLgo->Assemble(); 
-
-		if(rotation){
-
-			/*call rotational feedback  module: */
-			RSLgo_rot = new Vector<IssmDouble>(gsize); RSLgo_rot->Assemble();
-			femmodel->SealevelriseRotationalFeedback(RSLgo_rot,RSLg_old,&Ixz,&Iyz,&Izz, masks); 
-			RSLgo_rot->Assemble(); 
-
-			/*save changes in inertia tensor as results: */
-			femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,SealevelInertiaTensorXZEnum,Ixz));
-			femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,SealevelInertiaTensorYZEnum,Iyz));
-			femmodel->results->AddResult(new GenericExternalResult<IssmDouble>(femmodel->results->Size()+1,SealevelInertiaTensorZZEnum,Izz));
-
-			RSLgo->AXPY(RSLgo_rot,1); 
-		}
-
-		/*we need to average RSLgo over the ocean: RHS term  5 in Eq.4 of Farrel and clarke. Only the elements can do that: */
-		RSLgo_oceanaverage=femmodel->SealevelriseOceanAverage(RSLgo,masks, oceanarea);
-
-		/*RSLg is the sum of the eustatic term, and the ocean terms: */
-		RSLg_eustatic->Copy(RSLg); RSLg->AXPY(RSLgo,1); 
-		RSLg->Shift(-RSLgo_oceanaverage);
-
-		/*convergence criterion:*/
-		slrconvergence(&converged,RSLg,RSLg_old,eps_rel,eps_abs);
-		
-	
-		/*free ressources: */
-		delete RSLgo;
-		delete RSLgo_rot;
-
-		/*Increase count: */
-		count++;
-		if(converged==true){
-			break;
-		}
-		if(count>=max_nonlinear_iterations){
-			_printf0_("   maximum number of nonlinear iterations (" << max_nonlinear_iterations << ") exceeded\n"); 
-			converged=true;
-			break;
-		}	
-
-		/*some minor verbosing adjustment:*/
-		if(count>1)verboseconvolution=false;
-
-	}
-	if(VerboseConvergence()) _printf0_("\n              total number of iterations: " << count-1 << "\n");
-	
-	
-	delete RSLg_old;
-
-	return RSLg;
+	if(!rotation)return;
+
+	/*retrieve parameters: */
+	femmodel->parameters->FindParam(&load_love_k,NULL,NULL,LoadLoveKEnum);
+	femmodel->parameters->FindParam(&tide_love_h,NULL,NULL,TidalLoveHEnum);
+	femmodel->parameters->FindParam(&tide_love_k,NULL,NULL,TidalLoveKEnum);
+	femmodel->parameters->FindParam(&tide_love_k2secular,TidalLoveK2SecularEnum);
+	femmodel->parameters->FindParam(&moi_e,RotationalEquatorialMoiEnum);
+	femmodel->parameters->FindParam(&moi_p,RotationalPolarMoiEnum);
+
+	for(Object* & object : femmodel->elements->objects){
+		Element* element = xDynamicCast<Element*>(object);
+
+		element->SealevelchangeMomentOfInertiaCentroid(&moi_list[0],loads,slgeom);
+		element->SealevelchangeMomentOfInertiaSubElement(&moi_list_sub[0],loads, slgeom);
+
+		moi_list_cpu[0] += moi_list[0]+moi_list_sub[0];
+		moi_list_cpu[1] += moi_list[1]+moi_list_sub[1];
+		moi_list_cpu[2] += moi_list[2]+moi_list_sub[2];
+	}
+
+	for (int i=0;i<3;i++) moi_list[i]=0;
+
+	ISSM_MPI_Reduce (&moi_list_cpu[0],&moi_list[0],1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
+	ISSM_MPI_Bcast(&moi_list[0],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+
+	ISSM_MPI_Reduce (&moi_list_cpu[1],&moi_list[1],1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
+	ISSM_MPI_Bcast(&moi_list[1],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+
+	ISSM_MPI_Reduce (&moi_list_cpu[2],&moi_list[2],1,ISSM_MPI_DOUBLE,ISSM_MPI_SUM,0,IssmComm::GetComm() );
+	ISSM_MPI_Bcast(&moi_list[2],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
+
+	/*compute perturbation terms for angular velocity vector: */
+	m1 = 1/(1-tide_love_k[2]/tide_love_k2secular) * (1+load_love_k[2])/(moi_p-moi_e) * moi_list[0];
+	m2 = 1/(1-tide_love_k[2]/tide_love_k2secular) * (1+load_love_k[2])/(moi_p-moi_e) * moi_list[1];
+	m3 = -(1+load_love_k[2])/moi_p * moi_list[2];	// term associated with fluid number (3-order-of-magnitude smaller) is negelected
+
+	/*Assign output pointers:*/
+	polarmotionvector[0]=m1;
+	polarmotionvector[1]=m2;
+	polarmotionvector[2]=m3;
 } /*}}}*/
-void sealevelrise_core_elastic(Vector<IssmDouble>** pU_esa, Vector<IssmDouble>** pU_north_esa,Vector<IssmDouble>** pU_east_esa,FemModel* femmodel,Vector<IssmDouble>* RSLg, SealevelMasks* masks){ /*{{{*/
-
-	Vector<IssmDouble> *U_esa  = NULL; 
-	Vector<IssmDouble> *U_north_esa   = NULL; 
-	Vector<IssmDouble> *U_east_esa    = NULL; 
-
-	/*parameters: */
-	int  gsize;
-	bool spherical=true;
-
-	IssmDouble          *latitude   = NULL;
-	IssmDouble          *longitude  = NULL;
-	IssmDouble          *radius     = NULL;
-	IssmDouble          *xx     = NULL;
-	IssmDouble          *yy     = NULL;
-	IssmDouble          *zz     = NULL;
-	int  horiz;
-	
-	if(VerboseSolution()) _printf0_("	  computing vertical and horizontal geodetic signatures\n");
-
-	/*retrieve some parameters:*/
-	femmodel->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
-
-	/*find size of vectors:*/
-	gsize      = femmodel->nodes->NumberOfDofs(GsetEnum);
-
-	/*intialize vectors:*/
-	U_esa = new Vector<IssmDouble>(gsize);
-	if (horiz){
-		U_north_esa = new Vector<IssmDouble>(gsize);
-		U_east_esa = new Vector<IssmDouble>(gsize);
-	}
-
-	/*retrieve geometric information: */
-	VertexCoordinatesx(&latitude,&longitude,&radius,femmodel->vertices,spherical); 
-	VertexCoordinatesx(&xx,&yy,&zz,femmodel->vertices); 
-
-	/*call the elastic main modlule:*/ 
-	femmodel->SealevelriseElastic(U_esa,U_north_esa,U_east_esa,RSLg, masks);
-
-	/*Assign output pointers:*/
-	*pU_esa=U_esa;
-	if(horiz){
-		*pU_east_esa=U_east_esa;
-		*pU_north_esa=U_north_esa;
-	}
-
-	/*Free ressources: */
-	xDelete<IssmDouble>(longitude);
-	xDelete<IssmDouble>(latitude);
-	xDelete<IssmDouble>(xx);
-	xDelete<IssmDouble>(yy);
-	xDelete<IssmDouble>(zz);
-	xDelete<IssmDouble>(radius);
-}
-/*}}}*/
-void sealevelrise_core_viscous(Vector<IssmDouble>** pU_gia, Vector<IssmDouble>** pN_gia,FemModel* femmodel,Vector<IssmDouble>* RSLg){ /*{{{*/
-
-	/*variables:*/
-	Vector<IssmDouble> *U_gia  = NULL; 
-	Vector<IssmDouble> *N_gia  = NULL; 
-
-	/*parameters:*/
-	int					frequency;
-	IssmDouble          dt;
-	
-	if(VerboseSolution()) _printf0_("	  computing viscous components\n");
-
-	/*retrieve some parameters:*/
-	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
-	femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
-
-	/*recover GIA rates:*/
-	GetVectorFromInputsx(&U_gia,femmodel,UGiaRateEnum,VertexSIdEnum);
-	GetVectorFromInputsx(&N_gia,femmodel,NGiaRateEnum,VertexSIdEnum);
-
-	/*we just loaded rates, that's not what's being asked, scale by time:*/ 
-	U_gia->Scale(frequency*dt);
-	N_gia->Scale(frequency*dt);
-
-	/*Assign output pointers:*/
-	*pU_gia=U_gia;
-	*pN_gia=N_gia;
-
-}
-/*}}}*/
-void sealevelrise_diagnostics(FemModel* femmodel,Vector<IssmDouble>* RSLg){ /*{{{*/
-
-	/*compute spherical harmonics deg 1 and deg 2 coefficeints:*/
-
-}
-/*}}}*/
-void GetDynamicRate(Vector<IssmDouble> ** pdynamic_rate_g, FemModel* femmodel){ /*{{{*/
-
-	int dslmodel=-1;
-	IssmDouble time;
-
-	/*variables:*/
-	Vector<IssmDouble> *dynamic_rate_g  = NULL; 
-
-	/*Update steric rates before retrieving them on Vertex SID set:*/
-	femmodel->parameters->FindParam(&dslmodel,DslModelEnum);
-	femmodel->parameters->FindParam(&time,TimeEnum);
-	if(dslmodel==1){
-		TransientInput* transient_input  = femmodel->inputs->GetTransientInput(DslSeaSurfaceHeightChangeAboveGeoidEnum);
-		TriaInput* tria_input=transient_input->GetTriaInput(time);
-		Input* tria_input_copy=tria_input->copy();
-		tria_input_copy->ChangeEnum(DslDynamicRateEnum);
-		femmodel->inputs->AddInput(tria_input_copy);
-	}
-	else if(dslmodel==2){
-	
-		IssmDouble modelid;
-		
-		/*Recover modelid:*/
-		femmodel->parameters->FindParam(&modelid,DslModelidEnum);
-		modelid--; //from matlab. 
-		
-		/*find the DslSeaSurfaceHeightChangeAboveGeoidEnum dataset of transient inputs:*/
-		DatasetInput* dataset_input=femmodel->inputs->GetDatasetInput(DslSeaSurfaceHeightChangeAboveGeoidEnum);
-		
-		/*Go find the modelid'th transient input:*/
-		TriaInput* tria_input=dataset_input->GetTriaInputByOffset(reCast<int, IssmDouble>(modelid));
-		
-		/*Plug into DslDynamicRate input: */
-		Input* tria_input_copy=tria_input->copy();
-		tria_input_copy->ChangeEnum(DslDynamicRateEnum);
-		femmodel->inputs->AddInput(tria_input_copy);
-	}
-	else _error_("not implemented yet");
-
-	GetVectorFromInputsx(&dynamic_rate_g,femmodel,DslDynamicRateEnum,VertexSIdEnum);
-	*pdynamic_rate_g=dynamic_rate_g;
-}
-/*}}}*/
-void GetStericRate(Vector<IssmDouble> ** psteric_rate_g, FemModel* femmodel){ /*{{{*/
-
-	int dslmodel=-1;
-	IssmDouble time;
-
-	/*variables:*/
-	Vector<IssmDouble> *steric_rate_g  = NULL; 
-
-	/*Update steric rates before retrieving them on Vertex SID set:*/
-	femmodel->parameters->FindParam(&dslmodel,DslModelEnum);
-	femmodel->parameters->FindParam(&time,TimeEnum);
-	if(dslmodel==1){
-		TransientInput* transient_input  = femmodel->inputs->GetTransientInput(DslGlobalAverageThermostericSeaLevelChangeEnum);
-		TriaInput* tria_input=transient_input->GetTriaInput(time);
-		Input* tria_input_copy=tria_input->copy();
-		tria_input_copy->ChangeEnum(DslStericRateEnum);
-		femmodel->inputs->AddInput(tria_input_copy);
-	}
-	else if (dslmodel==2){
-		IssmDouble modelid;
-		
-		/*Recover modelid:*/
-		femmodel->parameters->FindParam(&modelid,DslModelidEnum);
-		
-		modelid--; //from matlab. 
-		
-		/*find the DslGlobalAverageThermostericSeaLevelChangeEnum dataset of transient inputs:*/
-		DatasetInput* dataset_input=femmodel->inputs->GetDatasetInput(DslGlobalAverageThermostericSeaLevelChangeEnum);
-		
-		/*Go find the modelid'th transient input:*/
-		TriaInput* tria_input=dataset_input->GetTriaInputByOffset(reCast<int, IssmDouble>(modelid));
-		
-		/*Plug into DslStericRate input: */
-		Input* tria_input_copy=tria_input->copy();
-		tria_input_copy->ChangeEnum(DslStericRateEnum);
-		femmodel->inputs->AddInput(tria_input_copy);
-	}
-	else _error_("not implemented yet");
-
-	GetVectorFromInputsx(&steric_rate_g,femmodel,DslStericRateEnum,VertexSIdEnum);
-	*psteric_rate_g=steric_rate_g;
-}
-/*}}}*/
-void SetBottomPressure(FemModel* femmodel){ /*{{{*/
-
-	int dslmodel=-1;
-	int type;
-
-	/*If we are running a dsl mme model, we need to update the bottom pressure first: */
-	femmodel->parameters->FindParam(&dslmodel,DslModelEnum);
-	if(dslmodel==2){
-	
-		IssmDouble modelid;
-		/*figure out the type of DslSeaWaterPressureChangeAtSeaFloor input:*/
-		type=femmodel->inputs->GetInputObjectEnum(DslSeaWaterPressureChangeAtSeaFloorEnum);
-
-		if(type==DatasetInputEnum){
-		
-			/*find the DslSeaWaterPressureChangeAtSeaFloor dataset of transient inputs:*/
-			DatasetInput* dataset_input=femmodel->inputs->GetDatasetInput(DslSeaWaterPressureChangeAtSeaFloorEnum);
-		
-			/*Recover modelid:*/
-			femmodel->parameters->FindParam(&modelid,DslModelidEnum);
-			modelid--; //from matlab. 
-		
-			/*Go find the modelid'th transient input:*/
-			TransientInput* transient_input=dataset_input->GetTransientInputByOffset(reCast<int, IssmDouble>(modelid));
-
-			/*Plug into DslSeaWaterPressureChangeAtSeaFloor input: */
-			Input* transient_input_copy=transient_input->copy();
-			transient_input_copy->ChangeEnum(DslSeaWaterPressureChangeAtSeaFloorEnum);
-			femmodel->inputs->AddInput(transient_input_copy);
-		}
-	}
-}
-/*}}}*/
-
-/*support routines:*/
+void        ConserveOceanMass(FemModel* femmodel,GrdLoads* loads, IssmDouble offset, SealevelGeometry* slgeom){ /*{{{*/
+
+	/*Shift sealevel loads by ocean average, only on ocean! :*/
+	for(Object* & object : femmodel->elements->objects){
+		Element* element = xDynamicCast<Element*>(object);
+		element->SealevelchangeShift(loads, offset,slgeom);
+	}
+	loads->AssembleSealevelLoads();
+
+} /*}}}*/
+IssmDouble* CombineLoads(IssmDouble* load,IssmDouble* subload,FemModel* femmodel, SealevelGeometry* slgeom,int loadtype,int nel){ /*{{{*/
+
+	int* indices=xNew<int>(nel);
+	for(int i=0;i<nel;i++)indices[i]=i;
+
+	Vector<IssmDouble>* vloadcopy=new Vector<IssmDouble>(nel);
+	IssmDouble* loadcopy=xNew<IssmDouble>(nel);
+
+	vloadcopy->SetValues(nel,indices,load,INS_VAL);
+	vloadcopy->Assemble();
+
+	if(subload){
+		for (int i=0;i<femmodel->elements->Size();i++){
+			if (slgeom->issubelement[loadtype][i]){
+				int se= slgeom->subelementmapping[loadtype][i];
+				IssmDouble subloadi=subload[se];
+				Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+				vloadcopy->SetValue(element->Sid(),subloadi,ADD_VAL);
+			}
+		}
+	}
+	vloadcopy->Assemble();
+	loadcopy=vloadcopy->ToMPISerial();
+
+	return loadcopy;
+
+} /*}}}*/
+
+/*Coupling routines:*/
 void TransferForcing(FemModel* femmodel,int forcingenum){ /*{{{*/
 
